---
sidebar_position: 4
description: Upload object part and other functions to work with S3 in the Open Integration Package, a free open-source integration library for 1C:Enterprise 8, OneScript and CLI
keywords: [1C, 1С, 1С:Enterprise, 1С:Enterprise 8.3, API, Integration, Services, Exchange, OneScript, CLI, S3]
---

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';

# Upload object part
 Uploads a part of an object for multipart uploading



`Function UploadObjectPart(Val Name, Val Bucket, Val BasicData, Val UploadID, Val PartNumber, Val Data, Val Directory = False) Export`

  | Parameter | CLI option | Type | Required | Description |
  |-|-|-|-|-|
  | Name | --name | String | &#x2714; | Name of the object in the bucket |
  | Bucket | --bucket | String | &#x2714; | Name of the bucket to put the object |
  | BasicData | --basic | Structure Of KeyAndValue | &#x2714; | Basic request data. See GetBasicDataStructure |
  | UploadID | --upload | String | &#x2714; | Upload ID. See InitPartsUpload |
  | PartNumber | --part | Number, String | &#x2714; | Number of the object part from 1 to 10000 |
  | Data | --content | BinaryData, String | &#x2714; | Part content for uploading |
  | Directory | --dir | Boolean | &#x2716; | True > Path style URL, False > Virtual hosted style URL |

  
  Returns:  Structure Of KeyAndValue - serialized JSON response from storage

:::tip
Method at AWS documentation: [UploadPart](https://docs.aws.amazon.com/AmazonS3/latest/API/API_UploadPart.html)

This is a service method. A `PutObject` method is intended for the common scenario of files uploading

Parameters with Binary data type can also accept file paths on disk and URLs
:::
<br/>


```bsl title="1C:Enterprise/OneScript code example"
    URL       = "storage-155.s3hoster.by";
    AccessKey = "BRN5RKJE67...";
    SecretKey = "NNhv+i9PrytpT8Tu0C1N...";
    Region    = "BTC";

    BasicData = OPI_S3.GetBasicDataStructure(URL, AccessKey, SecretKey, Region);

    Name = "fileChunked.mp3";

    Directory = True; // Formation URL in path-style
    Bucket = "";
    Entity = "https://hut.openintegrations.dev/test_data/song.mp3"; // URL, Path or Binary Data
    Entity = OPI_HTTPRequests.Get(Entity);

    Result = OPI_S3.InitPartsUpload(Name, Bucket, BasicData, , Directory);

    UploadID   = Result["response"]["InitiateMultipartUploadResult"]["UploadId"];
    TotalSize  = Entity.Size();
    ChunkSize  = 5242880;
    BytesRead  = 0;
    PartNumber = 1;

    DataReader   = New DataReader(Entity);
    SourceStream = DataReader.SourceStream();
    TagsArray    = New Array;

    While BytesRead < TotalSize Do

        CurrentReading = DataReader.Read(ChunkSize);
        CurrentData    = CurrentReading.GetBinaryData();

        If CurrentData.Size() = 0 Then
            Break;
        EndIf;

        Result = OPI_S3.UploadObjectPart(Name
            , Bucket
            , BasicData
            , UploadID
            , PartNumber
            , CurrentData
            , Directory);

        // ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

        BytesRead = SourceStream.CurrentPosition();

        ETag = Result["headers"]["Etag"];
        ETag = ?(ETag = Undefined, Result["headers"]["ETag"], ETag);

        TagsArray.Add(ETag);

        PartNumber = PartNumber + 1;

    EndDo;

    Result = OPI_S3.FinishPartsUpload(Name, Bucket, BasicData, UploadID, TagsArray, , Directory);
```
 

 <Tabs>
  
    <TabItem value="bash" label="Bash" default>
        ```bash
            # JSON data can also be passed as a path to a .json file
            
            oint s3 UploadObjectPart \
             --name "fileChunked.mp3" \
             --bucket "opi-gpbucket3" \
             --basic "{'URL':'storage-155.s3hoster.by','AccessKey':'***','SecretKey':'***','Region':'BTC','Service':'s3'}" \
             --upload "MDk2NGE5MDUtNDcxZS00ZDljLTkzYjMtODM5ZDM4NGMyMWVhLmQ4Y2IxYWEyLTRiZjUtNGNhNC04NTA1LTc2OWQ3ZTA3ZDhiNQ" \
             --part 2 \
             --content "/tmp/5ksewnln.nvq"
        ```
    </TabItem>
  
    <TabItem value="bat" label="CMD/Bat" default>
        ```batch
            :: JSON data can also be passed as a path to a .json file
            
            oint s3 UploadObjectPart ^
             --name "fileChunked.mp3" ^
             --bucket "opi-gpbucket3" ^
             --basic "{'URL':'storage-155.s3hoster.by','AccessKey':'***','SecretKey':'***','Region':'BTC','Service':'s3'}" ^
             --upload "MDk2NGE5MDUtNDcxZS00ZDljLTkzYjMtODM5ZDM4NGMyMWVhLmQ4Y2IxYWEyLTRiZjUtNGNhNC04NTA1LTc2OWQ3ZTA3ZDhiNQ" ^
             --part 2 ^
             --content "/tmp/5ksewnln.nvq"
        ```
    </TabItem>
</Tabs>


```json title="Result"
{
 "status": 200,
 "response": {},
 "headers": {
  "Accept-Ranges": "bytes",
  "Date": "Wed, 10 Dec 2025 20:41:08 GMT",
  "ETag": "\"adb76a9a9ff8226ed08fb6f343102908\"",
  "Server": "MinIO",
  "Strict-Transport-Security": "max-age=31536000; includeSubDomains",
  "Vary": "Origin, Accept-Encoding",
  "X-Amz-Id-2": "c2a299fbb3d6b004a6478b9b6d90c505d645df682f7a22b96b88f100b6280168",
  "X-Amz-Request-Id": "187FF542F5531E76",
  "X-Content-Type-Options": "nosniff",
  "X-XSS-Protection": "1; mode=block",
  "Content-Length": "0",
  "Content-Type": "text/plain; charset=utf-8"
 }
}
```
